#ifndef _CONTROLLER_H
#define _CONTROLLER_H


#define UPDATE_FREQ 3

#include "Levelwise.h"
#include "InMemoryJoinWrapper.h"
#include "Estimation.h"

#include <sys/time.h>
#include <time.h>


enum Phase {Initialize, Equalize, Normal};


int Compare_IMJ(const void *r1, const void *r2);
int Compare_Direct_IMJ(const void *r1, const void *r2);

int Collaps_Hash(int **&join_res, double *&output, int v_size, int relations_no);
int Collaps_Sort(int **&join_res, double *&output, int v_size, int relations_no);

int Collaps_Aggregate_Level(Record *join_res, double *&output, int v_size, OrderMaker *join_order);

int Collaps_Group_Level(Record *&join_res, double *&output, int v_size, OrderMaker *join_order);


class Controller {

public:
	Controller(int join_levels_no, LevelwiseStep **join_level, InMemoryJoinWrapper **imj_join_level, LevelwiseStep *aggregate_level, double conf_level, int groups_no, int tuples_stable, int var_estimates_needed);
	virtual ~Controller();

	void Control();

	void Control_StartUp();
	void Control_JoinLevel();
	void Control_UpJoinLevel();
	void Control_AggregateLevel();
	void Control_GroupAggregateLevel();

private:
	int join_levels_no;
	LevelwiseStep **join_level;
	InMemoryJoinWrapper **imj_join_level;

	LevelwiseStep *aggregate_level;

	Estimation *stat_module;

	double **tuples_no;

	double conf_level;

	int groups_no;
	Schema *group_schema;

	struct timeval stat_last_time, stat_current_time, stat_start_time;
};

#endif

