#ifndef _CONTROLLER_IQ_H
#define _CONTROLLER_IQ_H


// #define QUEUE_SIZE 100000

#include "Pipe.h"
#include "RelOpLevel.h"
#include "Record.h"



class ControllerInputQueue {
protected:
	Pipe *queue;
	int q_size;

	int imj_buffer_size;

	RelationalOpLevel *q_operator;

	pthread_t thr;
	pthread_mutex_t q_mutex;
	pthread_cond_t q_cond;

	int is_all_done;

public:
	ControllerInputQueue(RelationalOpLevel *q_operator, int imj_buffer_size, int queue_size);
	virtual ~ControllerInputQueue();


	// always non-blocking; returns one if the corresponding pipe has been closed
	int IsAllDone ();

	// always non-blocking; returns one if the corresponding pipe has been closed in the initialization phase
	int IsConstant ();

	// always non-blocking; returns the number of tuples beffered in the queue
	int GetNumTuples ();

	// always non-blocking if there are any records inside of the queue (it may
	// block if the queue is empty); returns the next record and the next record's
	// timestamp.  Returns 0 if it can't return any records because the correponding
	// pipe has shut down; otherwise, returns a 1
	int GetNextTuple (Record *nextOne, int &timeStamp);


private:
	//global thread function for each InputQueue
	static void *InputQueue_Thread (void *arg);
};


#endif

