#include "ExtendedHash.h"
#include "TwoWayList.cc"

using namespace std;

void RecordArray :: SetTimeStampSize(int size)
{
	timeStampSize = size;
}

RecordArray :: RecordArray()
{
    timeStampSize = 1;

    timeStamps.clear();

    allRecords.clear();

    ratios.clear();
}

int RecordArray :: GetNumOfRecs()
{
	return allRecords.size();
}


RecordArray :: RecordArray(int size)
{
    timeStampSize = size;

    timeStamps.clear();

    allRecords.clear();

    ratios.clear();
}

RecordArray :: RecordArray(RecordArray& myArray)
{
    timeStampSize = myArray.timeStampSize;

    timeStamps.clear();

    allRecords.clear();

    ratios.clear();
}

RecordArray :: ~RecordArray()
{
	int size = allRecords.size();
	
	for(int i=0;i<size;++i)
	{
		delete allRecords[i];
	}
	
	if(timeStampSize >0)
	{
		for(int i=0; i<size; ++i)
        {

            delete [] timeStamps[i];

            delete [] ratios[i];
        }
	}
	
	allRecords.clear();

    timeStamps.clear();
}

void RecordArray :: AddRecord(Record& addMe)
{
	Record *p =new Record;
	
	if(p==NULL)
	{
		cerr<<"Memory Allocation Error, RecordArray AddRecord\n";
		exit(0);
	}
	
	p->Consume(&addMe);

    allRecords.push_back(p);
	
}

void RecordArray :: AddRecord(Record& addMe, int *times, double* ratios)
{
	//cout<<"I am in 67. CurrentTimeStampSize ="<<timeStampSize<<endl;;
	Record *p =new Record;
	
	if(p==NULL)
	{
		cerr<<"Memory Allocation Error, RecordArray AddRecord\n";
		exit(0);
	}
	
	p->Consume(&addMe);

    allRecords.push_back(p);
	//cout<<"I am in 78.\n";

    int * q= new int [timeStampSize];

    if(q == NULL)
	{
		cerr<<"Memory Allocation Error, RecordArray AddRecord\n";
		exit(0);
	}


	for(int i=0; i<timeStampSize; ++i)
	{
		//cout<<timeStampSize<<endl;
		//cout<<"god save me\n";
		q[i]=times[i];
	}
	timeStamps.push_back(q);

    double* dq= new double [timeStampSize];

    if(dq == NULL)
	{
		cerr<<"Memory Allocation Error, RecordArray AddRecord\n";
		exit(0);
	}


	for(int i=0; i<timeStampSize; ++i)
	{
		//cout<<timeStampSize<<endl;
		//cout<<"god save me\n";
		dq[i]=ratios[i];
	}

    this->ratios.push_back(dq);
	
}

void RecordArray :: AddRecord(Record& addMe, int *times, int extraTime, double* ratios, double extraRatio)
{
	Record *p =new Record;
	
	if(p == NULL)
	{
		cerr<<"Memory Allocation Error, RecordArray AddRecord 100\n";
		exit(0);
	}
	
	//cout<<"105\n";
	p->Consume(&addMe);

    allRecords.push_back(p);
	
	
	int * q= new int [timeStampSize];

    if(q == NULL)
	{
		cerr<<"Memory Allocation Error, RecordArray AddRecord 109\n";
		exit(0);
	}
	//cout<<"116\n";

	for(int i=0; i<timeStampSize - 1; ++i)
		q[i]=times[i];

    q[timeStampSize-1] = extraTime;

    timeStamps.push_back(q);

	double * dq= new double [timeStampSize];

    if(dq == NULL)
	{
		cerr<<"Memory Allocation Error, RecordArray AddRecord 109\n";
		exit(0);
	}
	//cout<<"116\n";

	for(int i=0; i<timeStampSize - 1; ++i)
		dq[i]=ratios[i];

    dq[timeStampSize-1] = extraRatio;

    this->ratios.push_back(dq);
}

void RecordArray :: Print(int index, Schema& mySchema)
{
	allRecords[index]->Print(&mySchema);
	cout<<"timeStampSize is "<<timeStampSize<<endl;
    for(int i=0; i<timeStampSize; ++i)
	{
		cout<<timeStamps[index][i]<<'\t';
	}
	cout<<endl;
}

double RecordArray :: GetNumOfBytes()
{
	int size=allRecords.size();

    if(size == 0)
	  return 0.0;

    else 
	  return allRecords[0]->GetSize() * 1.0 * allRecords.size();
}

IntWrapper :: IntWrapper()
{
	value = -1;
};

IntWrapper :: IntWrapper(int inputVal)
{
	value = inputVal;
}

void IntWrapper :: Consume (IntWrapper* fromMe)
{
	this->value = fromMe->value;
}

void IntWrapper :: Copy (IntWrapper* fromMe)
{
	this->value = fromMe->value;
}


ExtendedHash :: ExtendedHash(OrderMaker& fromMe, CWHash* theHashObject) : myOrderMaker(fromMe)
{
	myHashFunc = theHashObject;
	size = 32;
	totalDistinctKeys = 0;
	AllIndices = new vector<HashPair*>*[size];

    for(int i = 0; i < size; ++i)
    {
		AllIndices[i]= NULL;

    }

	
}

ExtendedHash :: ExtendedHash(OrderMaker& fromMe, CWHash* theHashObject, int theSize): myOrderMaker(fromMe)
{
	myHashFunc = theHashObject;
	size = 	theSize;
	totalDistinctKeys = 0;
	AllIndices = new vector<HashPair*>*[size];

	for(int i=0; i < size; ++i)
		AllIndices[i] = NULL;
}

ExtendedHash ::ExtendedHash(ExtendedHash &myHashes) : myOrderMaker(myHashes.myOrderMaker)
{
    myHashFunc = myHashes.myHashFunc;
	totalDistinctKeys = 0;
    size = myHashes.size;

   AllIndices = new vector<HashPair*>*[size];

    for(int i = 0; i < size; ++i)
    {
		AllIndices[i]= NULL;

    }

}


ExtendedHash :: ~ExtendedHash()
{
	if(AllIndices == NULL) 
		return;
	for(int i =0 ;i< size;++i)
	{
		if(AllIndices[i]!=NULL && AllIndices[i]->size()>0)
		{

			for(int j = 0, k=AllIndices[i]->size(); j<k; ++j)
			delete (*(AllIndices[i]))[j];
		}
		
		
		delete AllIndices[i];
		AllIndices[i] = NULL;
	}	
	delete [] AllIndices;
}


void ExtendedHash :: AddRecIndex(Record& fromMe, int myIndex)
{
	
	unsigned int tmp = myHashFunc->Compute_Hash(&fromMe, &myOrderMaker);
	unsigned int index=tmp%size;
	
	//check whether we need to expand.
	if(totalDistinctKeys > EXTENDEDHASHCONST*size)
	{

		Expand();
		AddRecIndex(fromMe, myIndex);
		return;
	}	
	
	//if we do not need to expand, we find the right index and add in the record
	//if the entry is empty, we create one
	if (AllIndices[index] == NULL)
	{
		
		totalDistinctKeys++;
		AllIndices[index] = new vector<HashPair*>;
		AllIndices[index]->clear();
		//now we can add in the record directly
		HashPair* tmpHashPair = new HashPair;
		tmpHashPair->hashValue = tmp;
		IntWrapper tmpInt(myIndex);
		tmpHashPair->Indices.Insert(&tmpInt);
		AllIndices[index]->push_back(tmpHashPair);
	}		
	else
	{
		//check the hash value is in the list or not, if it is 
		//add into the twoway list otherwise, create an new entry and add in
		int tmpsize = AllIndices[index]->size();
		for(int w=0; w<tmpsize; ++w)
		{
			
			if((*(AllIndices[index]))[w]->hashValue == tmp)
			{
				IntWrapper tmpInt(myIndex);
				(*(AllIndices[index]))[w]->Indices.Insert(&tmpInt);
				return;	
			}	
			
		}
		
		//if comes here, there is no way to find a distinct key;
		
		totalDistinctKeys++;
		HashPair* tmpHashPair = new HashPair;
		tmpHashPair->hashValue = tmp;
		IntWrapper tmpInt(myIndex);
		tmpHashPair->Indices.Insert(&tmpInt);
		AllIndices[index]->push_back(tmpHashPair);
	}

}

void ExtendedHash :: DeleteIndex(Record& fromMe, int myIndex)
{
	unsigned int tmpHash = myHashFunc->Compute_Hash(&fromMe, &myOrderMaker);
	unsigned int index=tmpHash%size;
	
	if(AllIndices[index] == NULL)
	{//something is wrong
		cerr<<"the key to delete is not available.\n";
		exit(1);
	}

	//we have find the node and we need to find the twoway list
	int tmpsize = AllIndices[index]->size();
	TwoWayList<IntWrapper> *tmpList = NULL;
	for(int i=0;i<tmpsize;++i)
	{
		if((*(AllIndices[index]))[i]->hashValue == tmpHash)
		{
			tmpList =  &((*(AllIndices[index]))[i]->Indices);
			break;
		}
	}
	if(tmpList == NULL)
	{
		//something is wrong
		cerr<<"the key to delete is not available.\n";
		exit(1);
	}

	tmpList->MoveToStart();
	while(tmpList->RightLength()!=0)
	{
		IntWrapper * tmpWrapper = tmpList->Current(0);
		//we have find the place to delete
		if(tmpWrapper->value == myIndex)
		{
			IntWrapper tmp2;
			tmpList->Remove(&tmp2);
			return;
		}
		else
		tmpList->Advance();
	}
	cerr<<"The key to delete is not available\n";
	exit(1);
}

void ExtendedHash :: Expand()
{

    unsigned int tmpsize = size * 2;
  vector<HashPair*> ** NewIndices = new vector<HashPair*>*[tmpsize];

    for(int i = 0; i < tmpsize; ++i)
    {
		NewIndices[i]= NULL;

    }

       //cout<<"I am expanding : size="<<tmpsize<<endl;
    
	for(int i=0; i<size; ++i)
	{
		if(AllIndices[i] ==NULL) 
			continue;
		int mySize = AllIndices[i]->size();
		
		for(int j=0; j<mySize; ++j)
		{
			int tmp = (*(AllIndices[i]))[j]->hashValue % tmpsize;	
			if(NewIndices[tmp] ==NULL)
				NewIndices[tmp] = new vector<HashPair*>;
			NewIndices[tmp]->push_back((*(AllIndices[i]))[j]);
			(*(AllIndices[i]))[j]=NULL;
		}
		AllIndices[i]->clear();
		delete AllIndices[i];	
		AllIndices[i] = NULL;
	}
	delete [] AllIndices;	
	AllIndices = NewIndices;
	size = tmpsize;
}

int ExtendedHash :: Retrieve(unsigned int key, TwoWayList<IntWrapper> ** pIndex)
{
	
	unsigned int hashval = key%size;
	if (AllIndices[hashval] == NULL) 
		return -1;
	int size=AllIndices[hashval]->size();
	vector<HashPair*> &tmpVector = (*(AllIndices[hashval]));
	for(int i=0; i<size;++i)
	{
		if( tmpVector[i]->hashValue == key)
		{	
			*pIndex = &(tmpVector[i]-> Indices);
			return 0;
		}
	}
	return -1;
}

void ExtendedHash :: Print()
{
    this->myOrderMaker.Print();
    cout<<"size="<<this->size<<endl;
}
