#include "File.h"
#include "Record.h"
#include "Comparison.h"
#include "Schema.h"
#include "Hashes.h"

#include <iostream>
#include <stdio.h>


using namespace std;


int main(int argc, char **argv)
{
	if (argc == 4)
	{

		//first stripe
		char f_name[200];
		sprintf (f_name, "../../dbo/Tables/%s", argv[1]);

		File *f_in = new File();
		f_in->Open(1, f_name, FT_RECORD);

		Stripe_File *f_out = new Stripe_File();
		f_out->Open(0, argv[1], FT_NONE);

		Record *in_rec = new (std::nothrow) Record();
		if (in_rec == NULL)
		{
			cout << "ERROR : Not enough memory. EXIT !!!\n";
			exit(1);
		}

		while (f_in->NextRec(in_rec))
		{
			f_out->Append(in_rec);
		}

		delete in_rec;

		f_in->Close();
		f_out->Close();

		delete f_in;
		delete f_out;



		f_in = new File();
		f_out = new Stripe_File();

		//then check for correctness
		f_in->Open(1, f_name, FT_RECORD);
		f_out->Open(1, argv[1], FT_RECORD);


		in_rec = new (std::nothrow) Record();
		if (in_rec == NULL)
		{
			cout << "ERROR : Not enough memory. EXIT !!!\n";
			exit(1);
		}


		Record *in_rec1 = new (std::nothrow) Record();
		if (in_rec1 == NULL)
		{
			cout << "ERROR : Not enough memory. EXIT !!!\n";
			exit(1);
		}

		Schema *schema = new Schema(argv[2], argv[3]);
		OrderMaker *order = new OrderMaker(schema);

		Hash *hash = new Hash();


		while (f_in->NextRec(in_rec))
		{
			f_out->NextRec(in_rec1);

			if (hash->Compare(in_rec, in_rec1, order) != 0)
			{
				cout << "ERROR!!!";
			}
		}

		delete hash;

		delete schema;
		delete order;


		delete in_rec;
		delete in_rec1;

		f_in->Close();
		f_out->Close();

		delete f_in;
		delete f_out;


	}
	else
		cerr << "Usage: " << argv[0] << " [input file] [schema file] [schema name]\n";

	return(0);
}

