#ifndef _HASHES
#define _HASHES


#define MOD 2147483647
#define HL 31
#define HASH_DOMAIN 2147483647


#include "Record.h"
#include "Comparison.h"


class Hash {

protected:
	int Run(Record *left, Record *literal, Comparison *c);
	int Run(Record *left, Record *right, Record *literal, Comparison *c);

public:
	Hash();
	virtual ~Hash();

	virtual unsigned int Compute_Hash(Record *rec, OrderMaker *order);
	virtual unsigned int Compute_Hash(int *v, int n);

	virtual int Compare(Record *left, Record *right, OrderMaker *orderUs);
	virtual int Compare(Record *left, OrderMaker *order_left, Record *right, OrderMaker *order_right);

	virtual int Compare(Record *left, Record *literal, CNF *myComparison);
	virtual int Compare(Record *left, Record *right, Record *literal, CNF *myComparison);

	virtual void Print_Parameters();
};


class CWHash : public Hash {

protected:
	int params_no;
	unsigned long long *params;

	unsigned int buckets;

public:
	CWHash();
	CWHash(int params_no, unsigned int buckets);
	virtual ~CWHash();

	virtual unsigned int Compute_Hash(Record *rec, OrderMaker *order);
	virtual unsigned int Compute_Hash(int *v, int n);

	virtual int Compare(Record *left, Record *right, OrderMaker *order);
	virtual int Compare(Record *left, OrderMaker *order_left, Record *right, OrderMaker *order_right);

	virtual void Print_Parameters();
};


unsigned int hash31(unsigned long long a, unsigned long long b, unsigned long long x);

#endif
