#ifndef _MM_INDEX
#define _MM_INDEX

#include "Record.h"
#include "Comparison.h"
#include "Hashes.h"
#include "TwoWayList.h"


// A hash index with chaining is used for this purpose
class MMIndex {

private:
	TwoWayList<Record> *hash_table;
	int hash_size;

	OrderMaker *order;

	Hash *hash_func;
	Hash *exact_hash;

public:
	MMIndex(OrderMaker *order, int recs_no);
	virtual ~MMIndex();

	//this version is never used
//	void BuildIndex(char *run_name);

	void BuildIndex(Record *rec_array, int recs_no);

	int Find(Record *rec, OrderMaker *rec_order, TwoWayList<Record> *match_list);
};

#endif

