#ifndef PRIORITY_H
#define PRIORITY_H

#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>

#include "Record.h"
#include "TwoWayList.h"


struct Holder {

	Record *myRec;
	int timeStamp;

	void Consume (Holder *me);
	Holder ();
	virtual ~Holder ();
};

class RecPriorityQ {

private:

	TwoWayList <Holder> *allLists;
	int numLists;
	int *whichAreDone;

public:

        // the first parameter tells how many input relations there are;
        // the second tells which are already done with (whichAreDone[i] = 1 if
        // the i^th one is already done)
        RecPriorityQ (int numInputRels, int *whichAreDone);

        // adds a new record to the priority queue
        void Insert (Record *insertMe, int whichRel, int timeStamp);

        // tells the Q that the given relation has been exhausted
        void ThisGuyIsDone (int whichRel);

        // removes another record from the priority queue
        // The first param is the record to remove.  The second is the timestamp
        // of this record.  The third tells which relation it came from.  The
        // return value is a zero if that was the last record from that relation
        // that was present in the queue (a one otherwise)
        int Remove (Record *removeMe, int &timeStamp, int &whichRel);

	virtual ~RecPriorityQ ();
};

#endif
