#ifndef _SM_ORDER
#define _SM_ORDER

#include "Record.h"
#include "Comparison.h"
#include "Hashes.h"
#include "PriorityQueue.h"
#include "MMIndex.h"
#include "File.h"


int Compare(const void *r1, const void *r2);


class Order {

private:
	SortRecord *buffer;
	int buffer_size;

	int recs_no;
	int cur_index;

	char *run_name;
	int runs_no;

	OrderMaker *order;
	Hash *sort_func;

	Schema *schema;

	PriorityQueue *queue;
	MMIndex *index;

	Run_File_Interface *run_file;

protected:
	void SortRun();

	void WriteRun();

public:
	Order(int buffer_size, OrderMaker *order, Hash *sort_func, Schema *schema, char *run_name);
	virtual ~Order();

	int GetRecsNo();
	int GetRunsNo();

	//return 0 if insert into current run
	//return 1 if new run is created
	int Insert(Record *rec);

	void BuildIndex();
	void BuildQueue();

	int ExtractQueueTop(TwoWayList<Record> *top_list);
	int GetNextRec(Record *rec);

	int FindIndex(Record *rec, OrderMaker *rec_order, TwoWayList<Record> *match_list);

};

#endif

