#include <iostream>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>
#include <gsl/gsl_rng.h>


//no of tuples in each relation
#define T 30


using namespace std;


//aggregate function for each possible combination of tuples
double AGG[T][T];


int main()
{
	const gsl_rng_type *TYPE;
	gsl_rng *r;
	
	srand((unsigned int)time((time_t*)NULL));

	gsl_rng_env_setup();
	
	TYPE = gsl_rng_default;
	r = gsl_rng_alloc(TYPE);
	gsl_rng_set (r, rand());
	
	for (int i = 0; i < T; i++)
	{
		for (int j = 0; j < T; j++)
		{
			AGG[i][j] = gsl_rng_uniform (r);
		}
	}
	
	gsl_rng_free (r);	


	for (int i = 0; i < T; i++)
	{
		printf("{");
		for (int j = 0; j < T; j++)
		{
			if (j < T - 1)
				printf("%4.2f,", AGG[i][j]);
			else
				printf("%4.2f", AGG[i][j]);
		}

		if (i < T - 1)
			printf("},\n");
		else
			printf("}\n");
	}


	return 0;
}

