#include "NewCompilerOld.h"
#include "Controller.h"

#include <iostream>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>


using namespace std;


extern "C" {

	int yyparse(void);
	int yylex_destroy(void);

}

extern struct OperationList *finalope;


int main (int argc, char* argv[])
{

	int parse;

	if (!yyparse ()) {
		cout << "OK!\n";
		parse = 1;
	}
	else {
		cout << "Bad!\n";
		parse = 0;
	}

	yylex_destroy();

	if (parse == 0)
		return 1;


	srand((unsigned int)time((time_t*)NULL));

//	cout << argv[1] << "\n";

	OperationManager *a = new (std::nothrow) OperationManager(argv[1]);
	if (a == NULL)
	{
		cout << "ERROR : Not enough memory. EXIT !!!\n";
		exit(1);
	}

	a->RunAll();

	int groups_no = a->GetNumGroupsToDisplay();
	int tuples_stable = a->GetNumTuplesToStats();
	int queue_size = a->GetQueueSize();

	int var_estimates_needed = 100;


//	double max_err = atof(argv[2]);
	double conf_level = atof(argv[2]);

	Controller *c = new (std::nothrow) Controller(a->ActualJoinLevel + 1, a->join_level, a->imj_join_level, a->aggregate_level, conf_level, groups_no, tuples_stable, var_estimates_needed);
	if (c == NULL)
	{
		cout << "ERROR : Not enough memory. EXIT !!!\n";
		exit(1);
	}

	c->Control();

	delete c;


	delete a;

//	CleanOperationList(finalope);
}


/*
Q1 :
Result:             291979779305.0000
Tuples:                      58286457
*/

/*
Q2 :
Result:             388456205839.9050
Tuples:                      86304515
*/

/*
Q3 :
Result:               103732746079.11
Tuples:                       2711879
*/

/*
Q4 :
Result:            2402021351740.0000
Tuples:                     480097200
*/

/*
Q5 :
Result:              1134436098961.80
Tuples:                       6001215
*/

