#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>


using namespace std;


struct Pair {
	unsigned int initial_index;
	unsigned int random_no;
};


unsigned int Random_Generate() {
	/*
	random number generator has to be initialized before calling rand() in order to get
	different random numbers from one iteration to another
	*/

	unsigned int x = rand();
	unsigned int h = rand();

	return x ^ ((h & 1) << 31);
}



int Compare(const void *r1, const void *r2)
{
	Pair *a, *b;

	a = (Pair*)r1;
	b = (Pair*)r2;

	if (a->random_no < b->random_no)
		return -1;
	else if (a->random_no > b->random_no)
		return 1;
	else
		return 0;
}


int main(int argc, char *argv[])
{
	srand((unsigned int)time((time_t*)NULL));

	int set_size = atoi(argv[1]);
	int sample_size = atoi(argv[2]);

	Pair *elem = new Pair[set_size];
	for (int i = 0; i < set_size; i++)
	{
		elem[i].initial_index = i + 1;
		elem[i].random_no = Random_Generate();
	}

	qsort(elem, set_size, sizeof(Pair), Compare);

	cout << "Take the indices in the order of the articles starting from file 1 to file 4 for NYT, or file 10 for China Daily.\n";
	cout << "Ex: article 1 in NYT1.pdf has index 1; article 2 in NYT1.pdf has index 2; article 1 in NYT2.pdf has index 101; and so on.\n";
	cout << "The random sample contains the articles with the following indices:\n";
	for (int i = 0; i < sample_size; i++)
	{
		printf("Index = %10d\n", elem[i].initial_index);
	}

	delete [] elem;

	return 0;
}

